%%Error Calculations
load('modelica_data.mat');
load('psse_data.mat');



%% 
hfig = figure(1);
set(hfig, 'Position', [500 500 1100 700]);

%Terminal voltage
subplot(2,2,1);
set(gca,'FontSize',12)
hold on;
plot(time_m,ETERM_m,'LineWidth',3);
line_fewer_markers(time, ETERM,20,'--r','LineWidth',3); 
grid;
legend('Modelica','PSS/E');
ylim([0.99 1.05])
xlim([0 10]);
xlabel('Time (s)');
ylabel('Terminal voltage (pu)');

%Terminal voltage error
subplot(2,2,3);
set(gca,'FontSize',12)
[err_time err_vect rmse] = error_calc(time_m,ETERM_m,time,ETERM,1);
bar(err_time,err_vect,'g')
ylabel('Terminal voltage error (%)')
grid;
xlabel('Time (s)')
xlim([0 10])
ylim([0 0.02])

%Excitation voltage
subplot(2,2,2);
set(gca,'FontSize',12)
hold on;
plot(time_m, EFD_m,'LineWidth',3); 
line_fewer_markers(time, EFD, 20, '--r','LineWidth',3);
grid;

legend('Modelica','PSS/E');
xlim([0 10]);
ylim([1 4.1])
xlabel('Time (s)');
ylabel('Excitation voltage (pu)');

%Excitation voltage error
subplot(2,2,4);
set(gca,'FontSize',12)
[err_time err_vect rmse] = error_calc(time_m,EFD_m,time,EFD,1);
bar(err_time,err_vect,'g')
ylabel('Excitation voltage error (%)')
grid;
xlabel('Time (s)')
xlim([0 10])
ylim([0 1])
%%
hfig2 = figure(2);
set(hfig2, 'Position', [600 400 1100 700]);

%Generator active power
subplot(2,2,1);
set(gca,'FontSize',12)
hold on;
plot(time_m,P_m,'LineWidth',3);
line_fewer_markers(time, P,20,'--r','LineWidth',3); 
grid;
legend('Modelica','PSS/E');
ylim([0.25 0.65])
xlim([0 10]);
xlabel('Time (s)');
ylabel('Active power (pu)');

%Generator active power error
subplot(2,2,3);
set(gca,'FontSize',12)
[err_time err_vect rmse] = error_calc(time_m,P_m,time,P,1);
bar(err_time,err_vect,'g')
ylabel('Active power error (%)')
grid;
xlabel('Time (s)')
xlim([0 10])
ylim([0 0.1])


%Generator reactive power
subplot(2,2,2);
set(gca,'FontSize',12)
hold on;
plot(time_m, Q_m,'LineWidth',3); 
line_fewer_markers(time, Q, 20, '--r','LineWidth',3);
grid;

legend('Modelica','PSS/E');
xlim([0 10]);
ylim([-0.1 0.9])
xlabel('Time (s)');
ylabel('Reactive power (pu)');

%Generator reactive power error
subplot(2,2,4);
set(gca,'FontSize',12)
[err_time err_vect rmse] = error_calc(time_m,Q_m,time,Q,1);
bar(err_time,err_vect,'g')
ylabel('Reactive power error (%)')
grid;
xlabel('Time (s)')
xlim([0 10])
ylim([0 0.3])

