%Error calculations

function [err_time err_vect rmse] = err_calc(time1,signal1,time2,signal2,formula) 


yr=signal1;
tr=time1; 
ye=signal2;
te=time2; 
[trn,itr]=unique(tr,'stable');
yrn=yr(itr);
[ten,ite]=unique(te,'stable');
yen=ye(ite);
if ten~=trn
    warning('Sampling rate of the two signals is not equal. They will be resampled.'); 
    yenn=resample(yen,trn);
    
else 
    yenn=yen;
end
  
for i=1:length(yrn)
    eabs(i)=yenn(i)-yrn(i);  %absolute error
    e(i)=abs(eabs(i)/yrn(i))*100;    %relative percent error 
    mse(i)=eabs(i)^2;
end
err_time = trn; 

rmse=sqrt(1/length(yrn)*sum(mse));   %root mean squared error

disp(['Root means square error is: RMSE = ' num2str(rmse)]);

switch formula
    case 1
        err_vect = e; 
    case 2
        err_vect = eabs;
    otherwise
        err_vect = mse; 
end
        


%Plots
% subplot(2,1,1)
% plot(trn,yrn,'r',trn,yenn,'b')
% title('gen 58553')
% ylabel('bus voltage [pu]')
% legend('AKD','AKA')
% xlim([0 trn(length(trn))])
% subplot(2,1,2)
% bar(trn,eabs,'g')
% hold on
% title('Relative percent error')
% xlabel('Time [sec]')
% xlim([0 trn(length(trn))])
% strerr=['MSE= ',num2str(msqerr)];
% gtext(strerr,'FontSize',14);
    